#######################################################################
###                    The CIFF Proof Procedure                     ###
###        for Abductive Logic Programming with Constraints         ###
#######################################################################

#######################################################################
### GUI (file ciff-gui.tcl)                                         ###
#######################################################################
### v3.0: 23/06/2005 by Markos Hatzitaskos                          ###
#######################################################################

#######################################################################
### This file, along with `ciff-gui.pl', provide a simple graphical
### user interface for CIFF.
#######################################################################

# Set global variables.
global initialdir
global file
global query

proc setup_display {} {
	
	global file
	global query
	
	# Top level window settings #
	wm resizable . 0 0
	wm title . "CIFF"
	wm geometry . 830x534+182+269; update
	
	# Creating widgets #
	frame .main
	set base .main

	# Upper left
    	frame $base.fra30 -borderwidth 2 -relief groove -height 109 -width 415 
    	label $base.fra30.lab44 -font {{MS Sans Serif} 11 bold} -text {Program file:} 
    	label $base.fra30.lab45 -font {{MS Sans Serif} 9 {}} -text {(file in same folder as CIFF)} 
    	entry $base.fra30.ent46 -background #ffffff -textvariable "file" -width 386 
    	button $base.fra30.but23 -height 21 -pady 0 -text Open -width 74 -command { openfl }
    	
    	# Lower left
    	frame $base.fra31 -borderwidth 2 -relief groove -height 425 -width 415 
    	frame $base.fra31.cpd47 -borderwidth 1 -relief raised -height 285 -width 386 
    	scrollbar $base.fra31.cpd47.02 -command "$base.fra31.cpd47.3 yview" 
    	text $base.fra31.cpd47.3 -wrap word -background #ffffff -height 285 -width 148 -yscrollcommand "$base.fra31.cpd47.02 set" 
    	label $base.fra31.lab49 -font {{MS Sans Serif} 11 bold} -text {Definitions and Integrity Constraints (ICs):} 
    	button $base.fra31.but25 -height 21 -pady 0 -text Save -width 74 -command { save }
    	button $base.fra31.but26 -height 21 -pady 0 -text "Save As..." -width 74 -command { saveAs }
    	checkbutton $base.fra31.check1 -text "use NAF" -variable naf
    	
    	# Upper right
    	frame $base.fra33 -borderwidth 2 -relief groove -height 109 -width 415 
    	label $base.fra33.lab51 -font {{MS Sans Serif} 11 bold} -text Query: 
    	entry $base.fra33.ent52 -background #ffffff -textvariable "query" -width 386 
    	button $base.fra33.but24 -height 21 -pady 0 -text {Run CIFF} -width 74 -command { .main.fra34.cpd48.3 delete 1.0 "end - 1 chars" ; prolog "switch_negation_as_failure( $naf)";  .main.fra34.but27 config -state normal; prolog "switch_debugging( $v)" ; prolog "submit( '$file', $query )" ; .main.fra34.but27 config -state disabled; }
	label $base.fra33.lab52 -text "Debugging: "
	radiobutton $base.fra33.radio1 -variable v -value "off" -text "Off" 
	radiobutton $base.fra33.radio2 -variable v -value "on" -text "On"
	radiobutton $base.fra33.radio3 -variable v -value "step" -text "Step"
	radiobutton $base.fra33.radio4 -variable v -value "short" -text "Inf.Rules"
	radiobutton $base.fra33.radio5 -variable v -value "stats" -text "Stats"	
	
	# Lower right
    	frame $base.fra34 -borderwidth 2 -relief groove -height 425 -width 415 
    	frame $base.fra34.cpd48 -borderwidth 1 -relief raised -height 440 -width 389 
    	scrollbar $base.fra34.cpd48.02 -command "$base.fra34.cpd48.3 yview" 
    	text $base.fra34.cpd48.3 -wrap word -background #f3f3fc -height 340 -width 20 -yscrollcommand "$base.fra34.cpd48.02 set" 
    	label $base.fra34.lab50 -font {{MS Sans Serif} 11 bold} -text Answer(s): 
        button $base.fra34.but27 -height 21 -pady 0 -text "Next" -width 74 -state disabled -command { prolog_event next }
        
	# Setting geometry #
	
	# Upper left
    	grid $base.fra30 -in $base -column 0 -row 0 -columnspan 1 -rowspan 1 
    	place $base.fra30.lab44 -in $base.fra30 -x 10 -y 30 -anchor nw -bordermode ignore 
    	place $base.fra30.lab45 -in $base.fra30 -x 105 -y 30 -anchor nw -bordermode ignore 
    	place $base.fra30.ent46 -in $base.fra30 -x 15 -y 50 -width 386 -height 19 -anchor nw -bordermode ignore 
    	place $base.fra30.but23 -in $base.fra30 -x 325 -y 75 -width 74 -height 21 -anchor nw -bordermode ignore 
   	
   	# Lower left
   	grid $base.fra31 -in $base -column 0 -row 1 -columnspan 1 -rowspan 1 
    	place $base.fra31.cpd47 -in $base.fra31 -x 10 -y 30 -width 386 -height 350 -anchor nw -bordermode inside 
    	grid columnconf $base.fra31.cpd47 0 -weight 1
    	grid rowconf $base.fra31.cpd47 0 -weight 1
    	grid $base.fra31.cpd47.02 -in $base.fra31.cpd47 -column 1 -row 0 -columnspan 1 -rowspan 1 -sticky ns 
    	grid $base.fra31.cpd47.3 -in $base.fra31.cpd47 -column 0 -row 0 -columnspan 1 -rowspan 1 -sticky nesw 
    	place $base.fra31.lab49 -in $base.fra31 -x 10 -y 10 -anchor nw -bordermode ignore 
    	place $base.fra31.but25 -in $base.fra31 -x 240 -y 390 -width 74 -height 21 -anchor nw -bordermode ignore
    	place $base.fra31.but26 -in $base.fra31 -x 324 -y 390 -width 74 -height 21 -anchor nw -bordermode ignore
    	place $base.fra31.check1 -in $base.fra31 -x 10 -y 390 -width 74 -height 21 -anchor nw -bordermode ignore
    	
    	# Upper right
    	grid $base.fra33 -in $base -column 1 -row 0 -columnspan 1 -rowspan 1 
    	place $base.fra33.lab51 -in $base.fra33 -x 10 -y 30 -anchor nw -bordermode ignore 
    	place $base.fra33.ent52 -in $base.fra33 -x 15 -y 50 -width 386 -height 19 -anchor nw -bordermode ignore 
    	place $base.fra33.but24 -in $base.fra33 -x 327 -y 75 -width 74 -height 21 -anchor nw -bordermode ignore 
    	place $base.fra33.lab52 -in $base.fra33 -x 10 -y 75 -anchor nw -bordermode ignore
    	place $base.fra33.radio1 -in $base.fra33 -x 70 -y 75 -anchor nw -bordermode ignore
    	place $base.fra33.radio2 -in $base.fra33 -x 110 -y 75 -anchor nw -bordermode ignore
    	place $base.fra33.radio3 -in $base.fra33 -x 150 -y 75 -anchor nw -bordermode ignore
    	place $base.fra33.radio4 -in $base.fra33 -x 197 -y 75 -anchor nw -bordermode ignore
    	place $base.fra33.radio5 -in $base.fra33 -x 265 -y 75 -anchor nw -bordermode ignore
    	
    	# Lower right
    	grid $base.fra34 -in $base -column 1 -row 1 -columnspan 1 -rowspan 1 
    	place $base.fra34.cpd48 -in $base.fra34 -x 12 -y 32 -width 386 -height 350 -anchor nw -bordermode inside 
    	grid columnconf $base.fra34.cpd48 0 -weight 1
    	grid rowconf $base.fra34.cpd48 0 -weight 1
    	grid $base.fra34.cpd48.02 -in $base.fra34.cpd48 -column 1 -row 0 -columnspan 1 -rowspan 1 -sticky ns 
    	grid $base.fra34.cpd48.3 -in $base.fra34.cpd48 -column 0 -row 0 -columnspan 1 -rowspan 1 -sticky nesw 
    	place $base.fra34.lab50 -in $base.fra34 -x 10 -y 10 -anchor nw -bordermode ignore 
        place $base.fra34.but27 -in $base.fra34 -x 326 -y 390 -width 74 -height 21 -anchor nw -bordermode ignore
        
        # Main
	pack $base
	
	# Disable key sequences for answer text widget #
	
	bind $base.fra34.cpd48.3 <KeyPress> {
	    switch -- %K {
	        "Up" -
	        "Left" -
	        "Right" -
	        "Down" -
	        "Next" -
	        "Prior" -
	        "Home" -
	        "End" {
	        }
	
	        default {
	            break
	        }
	    }
	}
	
	# Also disable the cut and paste events.
	bind $base.fra34.cpd48.3 <<Paste>> "break"
	bind $base.fra34.cpd48.3 <<Cut>> "break"
}

# Set Initial Directory To Current Logged Directory 
set initialdir [pwd]

# Procedure that Opens file.
proc openfl {} {
  	global initialdir
  	global file
  	global query
  	
  	set prevfile $file
  	
  	set file_types {
  	  {"Tcl Files" { .alp .ALP } }
  	  {"All Files"  * }
  	  }
    
   	# Cleanup Filename And Text File Contents Widgets
  	set file [tk_getOpenFile -initialdir $initialdir -filetypes $file_types -title "Open File" -parent .]
  	if { $file == "" } {     
	   	set file $prevfile
	   	return; # they clicked cancel   
  	} 
  	
  	if {$file != ""} {
  		set initialdir [file dirname $file]
    		set retcd [ catch { set infile [open $file "r"] } ]
    
    		# Display Error Message Box If File Open Failure
    		if {$retcd == 1} {
      			wm title . "File Open Error"
      			set result [tk_messageBox -parent . -title "File Open Error" -type ok -icon error -message "Error Opening File: $file.\n"]
      		}

    		# Open File Successful Load Text File Contents Line By Line Until End Of File               
    		if {$retcd == 0} {  		      			
      			set inEOF -1
			set txln ""
			.main.fra31.cpd47.3 delete 1.0 "end - 1 chars"
			.main.fra34.cpd48.3 delete 1.0 "end - 1 chars"
			set query ""
			while {[gets $infile inln] != $inEOF} {
				set txln "$inln\n"
			        .main.fra31.cpd47.3 insert end $txln
			}
			close $infile
      
      		}
    	}
  	return $file
}


# Procedure that Saves As file.
proc saveAs {} {
   	set file [tk_getSaveFile -title "Save As..." -parent .]
   	if { $file == "" } {
   	     return; # they clicked cancel
   	   }
   	set x [catch {set fid [open $file w+]}]
   	set y [catch {puts $fid [.main.fra31.cpd47.3 get 1.0 end-1c]}]
   	set z [catch {close $fid}]
   	if { $x || $y || $z || ![file exists $file] || ![file isfile $file] || ![file readable $file] } {
   		tk_messageBox -parent . -icon error \
                 	-message "An error occurred while saving to \"$file\""
   	} 
 };
 
# Procedure that Saves file.
proc save {} {
	global file
   	set x [catch {set fid [open $file w+]}]
   	set y [catch {puts $fid [.main.fra31.cpd47.3 get 1.0 end-1c]}]
   	set z [catch {close $fid}]
   	if { $x || $y || $z || ![file exists $file] || ![file isfile $file] || ![file readable $file] } {
   		tk_messageBox -parent . -icon error \
   	              -message "An error occurred while saving to \"$file\""
   	} 
 };

# Initialize GUI.
setup_display
set v "off"
set naf 0


#######################################################################